SystemOrganization addCategory: #ApiManager!

Object subclass: #AMApi
	instanceVariableNames: 'endpoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApiManager'!

!AMApi commentStamp: 'RodrigoBistolfi 5/21/2012 12:58' prior: 0!
I am a collection of endpoints acting together for defining an API.!

Object subclass: #AMEndPoint
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApiManager'!

!AMEndPoint commentStamp: 'RodrigoBistolfi 5/21/2012 12:22' prior: 0!
I am an AMEndpoint. I represent the url for a HTTP REST service.
I understand a small dsl for handling urls with variable arguments or query strings:

	/api/user/{username}
	/api/search?q={keyword}

I can answer to accessor messages for this arguments:

	anEndPoint username: 'alan'.
	anotherEndpoint keyword: 'smalltalk'.
	!

Object subclass: #AMPredicate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApiManager'!

!AMPredicate commentStamp: 'RodrigoBistolfi 5/21/2012 13:03' prior: 0!
I represent a resource to be used as the body for a HTTP request.

	anAMRequest post: aPredicate!

Object subclass: #AMRequest
	instanceVariableNames: 'endpoint client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApiManager'!

!AMRequest commentStamp: 'RodrigoBistolfi 5/21/2012 12:27' prior: 0!
I am an HTTP client for making calls to HTTP REST services.
I hold an endpoint from which I get URLs and a ZnClient for delegating HTTP requests!

Object subclass: #AMResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ApiManager'!

!AMResponse commentStamp: 'RodrigoBistolfi 5/21/2012 13:01' prior: 0!
I represent the response from an HTTP REST API call.
I can answer messages for accessing the response data encoded in JSON or another serialization format. !
